package ch.fischer.ds_alg.lektion2.2;

import java.util.Iterator;

public class ThreeNumbers {
	final long start = 1;

	final long sum = 1907;

	final long sum3 = 2197298393L;

	// final long sum = 12;

	// final long sum3 = 216;

	SolutionSet solutions = new SolutionSet();

	public static void main(String[] args) {
		ThreeNumbers myThreeNumbers = new ThreeNumbers();
		myThreeNumbers.findSolutions();
	}

	public void findSolutions() {
		long z1, z2, z3;
		long timeNow = System.currentTimeMillis();
		for (z1 = start; z1 <= sum - 2 * start; z1++) {
			for (z2 = start; z2 <= sum - start - z1; z2++) {
				z3 = sum - z1 - z2;
				if (calulateSumofQubic(z1, z2, z3) == sum3) {
					solutions.add(new Solution(z1, z2, z3));
				}
			}
		}
		long timeDiff = System.currentTimeMillis()- timeNow;
		for (Iterator iter = solutions.iterator(); iter.hasNext();) {
			Solution solution = (Solution) iter.next();
			System.out.println(solution);
		}
		System.out.println(timeDiff);
	}

	public long calulateSumofQubic(long z1, long z2, long z3) {
		return (long) (Math.pow(z1, 3) + Math.pow(z2, 3) + Math.pow(z3, 3));
	}

}
